/* $XFree86: xc/lib/Xaw/Template.c,v 1.6 1999/06/06 08:48:13 dawes Exp $ */

#include <X11/IntrinsicP.h>
#include <X11/StringDefs.h>
#include "MyAppP.h"

/* Class Methods */
static void Initialize(Widget, Widget, ArgList, Cardinal *);
static void Exposed(Widget, XEvent *, Region);
static void Destroy(Widget);
static void Resize(Widget);

/* Actions */
static void Key(Widget, XEvent *, String *, Cardinal *);
static void Pointer(Widget, XEvent *, String *, Cardinal *);

/* Initialization */
#define offset(field) XtOffsetOf(MyAppRec, myapp.field)
static XtResource resources[] = {
  /*{
	name, class, type,
	size, offset,
	default_type, default_addr
    },*/
  /*{
	XtNmyappResource, XtCMyAppResource, XtRMyAppResource,
	sizeof(char *), offset(resource),
	XtRString, (XtPointer)"default"
    },*/
    {
	XtNmyappResource, XtCString, XtRString,
	sizeof(char *), offset(resource),
	XtRString, (XtPointer)"default"
    }
};
#undef offset

static XtActionsRec actions[] =
{
      /*{ name,		procedure },*/
	{ "key",	Key },
	{ "pointer",	Pointer },
};

static char translations[] =
	"<ButtonPress>:pointer()\n"
	"<KeyPress>:key()\n";

#define Superclass	(&widgetClassRec)
MyAppClassRec myappClassRec = {
	/* core */
	{
		(WidgetClass)Superclass,	/* superclass */
		"MyApp",			/* class_name */
		sizeof(MyAppRec),		/* widget_size */
		NULL,				/* class_initialize */
		NULL,				/* class_part_initialize */
		False,				/* class_inited */
		Initialize,			/* initialize */
		NULL,				/* initialize_hook */
		XtInheritRealize,		/* realize */
		actions,			/* actions */
		XtNumber(actions),		/* num_actions */
		resources,			/* resources */
		XtNumber(resources),		/* num_resources */
		NULLQUARK,			/* xrm_class */
		True,				/* compress_motion */
		True,				/* compress_exposure */
		True,				/* compress_enterleave */
		False,				/* visible_interest */
		Destroy,			/* destroy */
		Resize,				/* resize */
		Exposed,			/* expose */
		NULL,				/* set_values */
		NULL,				/* set_values_hook */
		XtInheritSetValuesAlmost,	/* set_values_almost */
		NULL,				/* get_values_hook */
		NULL,				/* accept_focus */
		XtVersion,			/* version */
		NULL,				/* callback_private */
		translations,			/* tm_table */
		XtInheritQueryGeometry,		/* query_geometry */
		XtInheritDisplayAccelerator,	/* display_accelerator */
		NULL,				/* extension */
	},
	/* myapp */
	{
		NULL,				/* extension */
	}
};

WidgetClass myappWidgetClass = (WidgetClass)&myappClassRec;

/* Widget needs initializing. */
static void
Initialize(Widget request, Widget widget, ArgList args, Cardinal *num_args)
{
	MyAppWidget w = (MyAppWidget)widget;

	printf("Initialize\n");
	w->myapp.private = NULL;
}

/* Part of widget needs redrawing. */
static void
Exposed(Widget widget, XEvent *event, Region region)
{
	MyAppWidget w = (MyAppWidget)widget;

	printf("Expose\n");
}

/* Widget is destroyed. */
static void
Destroy(Widget widget)
{
	MyAppWidget w = (MyAppWidget)widget;

	printf("Destroy\n");
}

/* Widget changes size. */
static void
Resize(Widget widget)
{
	MyAppWidget w = (MyAppWidget)widget;
	XWindowAttributes attr;

	if (XtIsRealized(widget)) {
	    XGetWindowAttributes(XtDisplay(widget), XtWindow(widget), &attr);
	    printf("Resize %d,%d\n", attr.width, attr.height);
	}
}

/* Key action */
static void
Key(Widget widget, XEvent *event, String *params, Cardinal *num_params)
{
	MyAppWidget w = (MyAppWidget)widget;
	KeySym keysym = XLookupKeysym(&event->xkey, 0);

	printf("Key %s\n", XKeysymToString(keysym));
}

/* Pointer action */
static void
Pointer(Widget widget, XEvent *event, String *params, Cardinal *num_params)
{
	MyAppWidget w = (MyAppWidget)widget;

	printf("Pointer %d,%d\n", event->xbutton.x, event->xbutton.y);
}
