#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>
#include <X11/Shell.h>
#include <X11/Xmu/Editres.h>

#include "MyApp.h"

static void Quit(Widget, XEvent *, String *, Cardinal *);

static String fallback_resources[] = {
	"?.width: 100",
	"?.height: 100",
	"?.allowShellResize: true",
	"*.saveUnder: true",
	NULL
};

static XrmOptionDescRec options[] = {
	/* { "-flag", ".myapp.flag", XrmoptionNoArg, (XtPointer)"true" }, */
	/* { "-option", ".myapp.option", XrmoptionSepArg }, */
};

static XtActionsRec actions[] = {
	{ "quit",	Quit }
};

static XtAppContext appContext;
static Widget toplevel;

int
main(argc, argv)
	int argc;
	char *argv[];
{
	Display *display;
	Atom wm_delete_window;

	toplevel = XtOpenApplication(
		&appContext,			/* app_context_return */
		"MyApp",			/* application_class */
		options, XtNumber(options),	/* options, num_options */
		&argc, argv,			/* argc, argv */
		fallback_resources,		/* fallback_resources */
		sessionShellWidgetClass,	/* widget_class */
		NULL, 0				/* args, num_args */
	);

	XtAppAddActions(appContext, actions, XtNumber(actions));

	/* Create the widget */
	XtCreateManagedWidget("myapp", myappWidgetClass, toplevel,
	    NULL, 0);
	XtRealizeWidget(toplevel);

	/* Translate window manager close request into quit */
	display = XtDisplay(toplevel);
	wm_delete_window = XInternAtom(display, "WM_DELETE_WINDOW", False);
	XSetWMProtocols(display, XtWindow(toplevel), &wm_delete_window, 1);
	XtOverrideTranslations(toplevel,
	    XtParseTranslationTable("<Message>WM_PROTOCOLS:quit()"));

	/* Enable editres(1) */
	XtAddEventHandler(toplevel, 0, True, _XEditResCheckMessages, NULL);

	XtAppMainLoop(appContext);
	exit(0);
}

static void
Quit(Widget w, XEvent *e, String *params, Cardinal *num_params)
{
	XtDestroyWidget(toplevel);
	XtAppSetExitFlag(appContext);
}
